#include <stdio.h>

double faktorijel(int n)
{
    int i;
    double f=1;

    for(i=1; i<=n; i++)
        f*=i;

    return f;
}

double potencijaodpet(int n)
{
    int i;
    double pot=1;

    for(i=1; i<=n; i++)
        pot*=5;

    return pot;
}

double horner(int n, double a[], double x)
{
    double p=0;
    int i;

    for(i=n; i>=0; i--)
        p=p*x+a[2*i+1]/faktorijel(2*i)-a[2*(n-i)]*potencijaodpet(i);

    return p;
}

double horner_lin(int n, double a[], double x)
{
    double p1=0, p2=0, fakt=1;
    int i;

    for(i=1; i<=2*n; i++)
        fakt*=i;

    for(i=n; i>=0; i--){
        p1=p1*x+a[2*i+1]/fakt;
        if(i)
            fakt/=2*i*(2*i-1);

        p2=p2*(5*x)-a[2*(n-i)];
    }

    return p1+p2;
}

int main(void)
{
    return 0;
}
